'<ADbasic Header, Headerversion 001.001>
'<Header End>
'ADBASIC-SYSTEM-FILE--V1.00--0000--0000--INC--ALL
'
'################################################################
'#                        ADwin_utils.inc                       #
'#              INCLUDE-file for all ADwin-Systems              #
'################################################################
'#                                                              #
'# Contents: FUNCTIONs for processors T9, T10, T11, T12, T12.1  #
'#                                                              #
'#  10.11.2017  JK   creation (Beta)                            #
'#  21.01.2019  JK   added DEBUG MODE code
'#  22.01.2019  GC   added documentation
'#  28.01.2019  JK   my_idx (important, when a Fifo is passed)  #
'#  28.01.2019  JK   my_data (important, when a Fifo is passed) #
'#                                                              #
'# Attention:                                                   #
'#   - Do not copy the first source line (containing            #
'#     "'ADBASIC-SYSTEM-FILE...") to user files !               #
'#     Otherwise the Syntax color may be not correct.           #
'#                                                              #
'################################################################

#If Processor = T9 Then
#EndIf
#If Processor = T10 Then
#EndIf
#If Processor = T11 Then
#EndIf
#If Processor = T12 Then
Import ADwin_utils.LiC
#EndIf
#If Processor = T121 Then
Import ADwin_utils.1.LiC
#EndIf




#If Processor = T12,T121 Then
' only available for T12 and T12.1 processor
  
'***************************************************************
'''Returns a value of data type Long from a global array DATA_x with a given number x.
'''+ret_val:   Value of array element DATA_x[index], where x = data_no.
'''data_no:    Number x (1..200) of the global array DATA_x.
'''index:      Index of the array element to be read.
'''**************************************************************
Function Read_Data_X_Long(data_no, index) as Long

#IF DEBUG_MODE = ON THEN

  dim my_idx as long
  dim my_data as long
  dim ret_val as long
  
  my_idx = index
  my_data = data_no
  ret_val =  data_x_Long_debug_lib(my_data, my_idx) ' do some checks 
  if ( ret_val <> 0 ) then  
    PROCESS_ERROR = 500000 + ret_val 
    Read_Data_X_Long = 0
  else
    Read_Data_X_Long = Read_Data_X_Long_lib(my_data, my_idx)
  endif    
    
#else
  Read_Data_X_Long = Read_Data_X_Long_lib(data_no, index)
#endif  
    
EndFunction


'***************************************************************
'''Returns a value of data type Float32 from a global array DATA_x with a given number x.
'''+ret_val:   Value of array element DATA_x[index], where x = data_no.
'''data_no:    Number x (1..200) of the global array DATA_x.
'''index:      Index of the array element to be read.
'''**************************************************************
Function Read_Data_X_Float32(data_no, index) as Float32

#IF DEBUG_MODE = ON THEN

  dim my_idx as long
  dim my_data as long
  dim ret_val as long

  my_idx = index
  my_data = data_no
  ret_val =  data_x_Float32_debug_lib(my_data, my_idx) ' do some checks 
  if ( ret_val <> 0 ) then  
    PROCESS_ERROR = 510000 + ret_val 
    Read_Data_X_Float32 = 0
  else
    Read_Data_X_Float32 = Read_Data_X_Float32_lib(my_data, my_idx)
  endif    
  
#else
  Read_Data_X_Float32 = Read_Data_X_Float32_lib(data_no, index)
#endif  
    
EndFunction

'***************************************************************
'''Returns a value of data type Float64 from a global array DATA_x with a given number x.
'''+ret_val:   Value of array element DATA_x[index], where x = data_no.
'''data_no:    Number x (1..200) of the global array DATA_x.
'''index:      Index of the array element to be read.
'''**************************************************************
Function Read_Data_X_Float64(data_no, index) as Float64

#IF DEBUG_MODE = ON THEN

  dim my_idx as long
  dim my_data as long
  dim ret_val as long

  my_idx = index
  my_data = data_no
  ret_val =  data_x_Float64_debug_lib(my_data, my_idx) ' do some checks 
  if ( ret_val <> 0 ) then  
    PROCESS_ERROR = 520000 + ret_val 
    Read_Data_X_Float64 = 0
  else
    Read_Data_X_Float64 = Read_Data_X_Float64_lib(my_data, my_idx)
  endif    
  
#else
  Read_Data_X_Float64 = Read_Data_X_Float64_lib(data_no, index)
#endif  
    
EndFunction

'***************************************************************
'''Writes a value of data type Long into a global array Data_x with a given number x.
'''data_no:    Number x (1..200) of the global array DATA_x.
'''index:      Index of the array element to be written.
'''value:      Value of data type Long to be written to DATA_x[index].
'''**************************************************************
Sub Write_Data_X_Long(data_no, index, value)

#IF DEBUG_MODE = ON THEN

  dim my_idx as long
  dim my_data as long
  dim ret_val as long

  my_idx = index
  my_data = data_no
  ret_val =  data_x_Long_debug_lib(my_data, my_idx) ' do some checks 
  if ( ret_val <> 0 ) then  
    PROCESS_ERROR = 530000 + ret_val 
  else
    Write_Data_X_Long_lib(my_data, my_idx, value)
  endif    
  
#else
  Write_Data_X_Long_lib(data_no, index, value)
#endif  
    
EndSub

'***************************************************************
'''Writes a value of data type Float32 into a global array Data_x with a given number x.
'''data_no:    Number x (1..200) of the global array DATA_x.
'''index:      Index of the array element to be written.
'''value:      Value of data type Float32 to be written to DATA_x[index].
'''**************************************************************
Sub Write_Data_X_Float32(data_no, index, value)

#IF DEBUG_MODE = ON THEN

  dim my_idx as long
  dim my_data as long
  dim ret_val as long

  my_idx = index
  my_data = data_no
  ret_val =  data_x_Float32_debug_lib(my_data, my_idx) ' do some checks 
  if ( ret_val <> 0 ) then  
    PROCESS_ERROR = 540000 + ret_val 
  else
    Write_Data_X_Float32_lib(my_data, my_idx, value)
  endif    
  
#else
  Write_Data_X_Float32_lib(data_no, index, value)
#endif  
    
EndSub

'***************************************************************
'''Writes a value of data type Float64 into a global array Data_x with a given number x.
'''data_no:    Number x (1..200) of the global array DATA_x.
'''index:      Index of the array element to be written.
'''value:      Value of data type Float64 to be written to DATA_x[index].
'''**************************************************************
Sub Write_Data_X_Float64(data_no, index, value)

#IF DEBUG_MODE = ON THEN

  dim my_idx as long
  dim my_data as long
  dim ret_val as long

  my_idx = index
  my_data = data_no
  ret_val =  data_x_Float64_debug_lib(my_data, my_idx) ' do some checks 
  if ( ret_val <> 0 ) then  
    PROCESS_ERROR = 550000 + ret_val 
  else
    Write_Data_X_Float64_lib(my_data, my_idx, value)
  endif    
  
#else
  Write_Data_X_Float64_lib(data_no, index, value)
#endif  
    
EndSub

#endif
