'<TiCoBasic Header, Headerversion 001.001>
' Foldings                       = 28,135
'<Header End>
'ADBASIC-SYSTEM-FILE--V1.00--0000--0000--INC--PRO
'<SMARTFORMAT OFF> do not remove !!!
'
'##############################################################################
'#                        AOUT1_Tico.inc                                      #
'#              INCLUDE-file for PROII AOUT 1/16                              #
'##############################################################################
'#                                                                            #
'#                                                                            #
'#  05.12.2013  mf   creation                                                 #
'#  04.11.2016  mf   Calc_Processdelay                                        #
'#  25.01.2021  mf   Calc_TicksToNs                                           #
'#                                                                            #
'#                                                                            #
'# Attention:                                                                 #
'#   - Do not copy the first source line (containing                          #
'#     "'ADBASIC-SYSTEM-FILE...") to user files !                             #
'#     Otherwise the Syntax color may be not correct.                         #
'#   - This includefile requires ADbasic 5 or higher!                         #
'#                                                                            #
'##############################################################################

#if adwin_system=ADwin_ProII
#else
#error("This include file can only be used with the ADwin ProII")  
#endif

'<REGION> System

'***************************************************************
''' Converts a process frequency [Hz] into processor ticks (processdelay or cycle time).
''' frequency:  frequency[Hz]
'''*************************************************************
Function Calc_Processdelay(frequency) as long
  
#if prozessor=tico1
  calc_processdelay=50000000/(frequency)
#else
  calc_processdelay=100000000/(frequency)
#endif
  
endfunction




'***************************************************************
''' Converts timer ticks into ns
''' ticks: counter value ticks into ns
'''*************************************************************
Function Calc_TicksToNs(ticks) As long
  Calc_TicksToNs=(ticks)*20
endfunction

'---------------------------------------------------------------
' If a low-priority process accesses a Pro-module it must not be
' interrupted by any other process !!!
'---------------------------------------------------------------

Sub Sub_Begin_Critical_Section() ''<HIDE>
#If PRIORITAET = LOW
  Begin_Critical_Section
#EndIf
EndSub

Sub Sub_End_Critical_Section() ''<HIDE>
#If PRIORITAET = LOW
  End_Critical_Section
#EndIf
EndSub

'******************************************************************************
'''Switches the LED on or off.
'''value: 
'''+  0 off
'''+  1 on
'''****************************************************************************
SUB Set_LED(value)
  out (80804000H, value)
ENDSUB

'******************************************************************************
'''Checks the LED.
'''+Return:
'''+   0 off
'''+   1 on
'''****************************************************************************
FUNCTION Check_LED() AS Long
  Check_LED=in(80804000h)
ENDFUNCTION


'*******************************************************************************
'''Activates or deactivates the external Event input.
'''value:
'''+     0 deactivate
'''+     1 activate
'''*****************************************************************************
SUB Event_Enable(value)
  'DIM old AS Long
  '
  'old=in(80804800h)
  'old =(old AND 0FFFFFFFEH) or value
  'out (80804800h, old)
  
  out(80804800h,(in(80804800h) AND 0FFFFFFFEH) or value)

ENDSUB

'*******************************************************************************
'''Configures the external Event input.
'''min_hold:
'''+     0=15 ns (default) 
'''+     1 =50 ns
'''edge:
'''+      1 rising edge (default)
'''+      2 falling edge
'''+      3 rising & falling edge
'''prescale: 1 to 255
'''****************************************************************************
SUB Event_Config(min_hold,edge,prescale)
  out (80804800h,(in(80804800h) AND 0FFFFFFE3H) or shift_left((min_hold AND 1),4) or shift_left((edge AND 3),2))
  out (80804810h,prescale AND 0FFH)
ENDSUB

'*******************************************************************************
'''Creates an event for the master cpu.
'''*****************************************************************************
SUB Trigger_Event()
  out (108041E0h, 1)
ENDSUB

'<ENDREGION>

'<REGION> DAC

'********************************** DAC ***************************************
'''Converts the digital value to an analog output.
'''dac_no: channel number of analog output (1..1)
'''value: output value (0..65535)
'''******************************************************************************
SUB DAC(dac_no, value)
  out(22FFh + dac_no,value)
ENDSUB

'******************************************************************************
'''Sets DAC-register to desired value.
'''DAC_No: channel number of analog output (1..1)
'''value: output value (0..65535)
'''******************************************************************************
SUB Write_DAC(dac_no, value)
  out(21FFh + dac_no,value)
  nops(3)
ENDSUB

'********************************************************************************
'''Simultaneously start conversion of all DAC on this module.
'''******************************************************************************
SUB Start_DAC()
  out(7002h,0)
ENDSUB

*****************************************************************************
'''Sets DAC-register to desired value.
''' DAC_No: 
'''+         0->Channel 1 and 2
'''+         1->Channel 3 and 4
'''+         2->Channel 5 and 6
'''+         3->Channel 7 and 8
'''value: output value 32Bit
'''******************************************************************************
SUB Write_DAC32(dac_no, value)
  out(2400h + dac_no,value)
  nops(3)
ENDSUB

'<ENDREGION>








